<div class="container mt-2">
  <div class="nav justify-content-endow">
    <div class="col col-md4 offset-md justify-content-end">
      <kendo-grid #kendoGridInstance
                  [data]="gridData"
                  [kendoGridBinding]="gridView"
                  [filterable]="true"
                  [pageSize]="pageSize"
                  [skip]="skip"
                  [reorderable]="true"
                  [resizable]="true"
                  [pageable]="{
                                buttonCount: 5,
                                info: true,
                                type: 'input',
                                pageSizes: [10, 25, 50, 100],
                                previousNext: true,
                                position: 'bottom'
                               }"
                  [sort]="sort"
                  [sortable]="{allowUnsort: allowUnsort,mode: 'single'}"
                  (sortChange)="sortChange($event)"
                  (pageChange)="pageChange($event)"
                  [(selectedKeys)]="gridSelectRow"
                  (add)="createOrder($event)"
                  (edit)="editOrderData($event)"
                  (save)="saveOrderData($event)"
                  (cancel)="cancelHandler($event)"
                  (remove)="openDeleteModal($event)"
                  kendoGridSelectBy="id">
        <ng-template kendoGridToolbarTemplate>
          <button kendoGridAddCommand type="button" [icon]="'add'" title="Create" [disabled]="!this.is_create"
                  style="background-color: #007bff; color: white; margin-left: 94%;"></button>
        </ng-template>

        <kendo-grid-column *ngFor="let column of fileColumns"
                           [title]="column.title"
                           [field]="column.field" [headerStyle]="{ 'font-weight': 'bold' }">
          <ng-template kendoGridCellTemplate let-dataItem >
            <!-- Setting Directive for checking the patterns-->
                        <span *ngIf="column.field === 'id'" title="{{dataItem[column.field]}}" >
                            {{dataItem[column.field]}}</span>
            <span *ngIf="column.field === 'state'|| column.field === 'name'" title="{{dataItem[column.field]}}">
                            <ng-template kendoGridEditTemplate let-column="column" let-formGroup="formGroup" let-isNew="isNew">
                             <input type="text" [formControl]="formGroup.get(column.field)" inputSelector [inputrestriction]="'[a-zA-Z]'">
                            </ng-template>{{dataItem[column.field] }}
            </span>

            <span *ngIf="column.field === 'item'" title="{{dataItem[column.field]}}">
                            <ng-template kendoGridEditTemplate let-column="column" let-formGroup="formGroup" let-isNew="isNew">
                             <input type="text"  pattern="[a-zA-Z0-9]+" [formControl]="formGroup.get(column.field)" inputSelector [inputrestriction]="'[a-zA-Z0-9]'">
                            </ng-template>{{dataItem[column.field] }}
            </span>

            <span *ngIf="column.field === 'zip'" title="{{dataItem[column.field]}}">
                            <ng-template kendoGridEditTemplate let-column="column" let-formGroup="formGroup" let-isNew="isNew">
                             <input type="text" minlength="6" maxlength="6" [formControl]="formGroup.get(column.field)" inputSelector [inputrestriction]="'[0-9]'">
                            </ng-template>{{dataItem[column.field] }}
            </span>

            <span *ngIf="column.field === 'quantity' || column.field === 'amount'" title="{{dataItem[column.field]}}">
                            <ng-template kendoGridEditTemplate let-column="column" let-formGroup="formGroup" let-isNew="isNew">
                             <input type="number" step="any" [formControl]="formGroup.get(column.field)">
                            </ng-template>{{dataItem[column.field] }}
            </span>
          </ng-template>
        </kendo-grid-column>


        <kendo-grid-command-column title="Actions" [includeInChooser]="false">
          <ng-template kendoGridCellTemplate let-isNew="isNew">
            <button kendoGridEditCommand [icon]="'edit'" style="background-color: orange; color:white"
                    title="Edit" [disabled]="!is_edit"></button>
            <button kendoGridSaveCommand type="button" [icon]="'save'"
                    style="background-color: #008000; color:white" title="Save"></button>
            <button [icon]="'cancel'" kendoGridCancelCommand style="background-color: #ff0000; color:white" title="Cancel"></button>
            <button kendoGridRemoveCommand type="button" [icon]="'delete'" title="Delete"
                    style="background-color: #ff0000; color:white"  [disabled]="!is_delete"></button>
          </ng-template>
        </kendo-grid-command-column>


        <ng-template kendoPagerTemplate>
          <kendo-pager-prev-buttons></kendo-pager-prev-buttons>
          <kendo-pager-input></kendo-pager-input>
          <kendo-pager-next-buttons></kendo-pager-next-buttons>
          <kendo-pager-page-sizes [pageSizes]="pageSizes"></kendo-pager-page-sizes>
          <kendo-pager-info></kendo-pager-info>
        </ng-template>
      </kendo-grid>
    </div>
  </div>
</div>

<!-- Delete Modal -->
<div class="modal fade" id="deleteModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="exampleModalLabel">Delete Confirmation</h5>
        <button type="button"  aria-label="Close" (click)="retriveButtons()">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        Are you sure to delete this order?
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" (click)="retriveButtons()">Close</button>
        <button type="button" class="btn btn-danger" (click)="confirmDelete()" >Confirm Delete</button>
      </div>
    </div>
  </div>
</div>


